VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsNlsConv"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' clsNlsConv Copyright (C)2004 Klaus Dahlenburg, INCOMM GmbH
' Published under the terms and conditions of GNU General Public License Version 2, 1991 or later
'
' ===============
' changes:
'   dah-7 20/1/2004 - the property let changed to a sub to pass on the current
'                     version as well
'   dah-8 19/6/2005 - method to read the private strings implemented
'
' ===============
'
' Notes:
'          - benoetigt das Module Functions.bas mit der Methode ChkFld()
'          - MicroSoft Scripting Runtime muss im Projekt referenziert sein
'
Option Explicit
'
Private sNlsDef As String        ' default properties
Private sNlsNls As String        ' specific Nls properties
Private fso As FileSystemObject  ' ms scripting Runtime!
Private sFehler As String
Private lRcNls As Long
Private sRetStr As String
Private sUseNlsDsn As String
Private tmp As Variant
Private sSubData() As String
'
Private sBuffer As String                       ' return data as C-String !
Private sErgebnis As String                     ' the converted string in VB format
Private lLaenge As Long                         ' length of returned data
'
Private Declare Function GetPPStrings Lib "kernel32" Alias "GetPrivateProfileStringA" _
                                                       (ByVal lpApplicationName As String, _
                                                        ByVal lpKeyName As Any, _
                                                        ByVal lpDefault As String, _
                                                        ByVal lpReturnedString As String, _
                                                        ByVal nSize As Long, _
                                                        ByVal lpFileName As String) As Long
'
'
Public Function getString(sKey As String, _
                lRc As Long, _
                vSubData As Variant, _
                Optional sApplicat As String = "Inserts") As String
'
Dim strLen As Long
Dim sChar As String
Dim i As Long
'
    sFehler = vbNullString
    getString = vbNullString
    On Error GoTo err_handler:
    '
    lRc = 0
    '
    lRcNls = getNlsString(sDateiName:=sUseNlsDsn, _
                sVariable:=sKey, _
                sReturn:=sRetStr, _
                sApplication:=sApplicat)
    '
    If lRcNls <> 0 Then
        lRc = lRcNls
        getString = "? " & sKey & " ?  "
        Exit Function
    End If
    '
    ' if the request was for something other
    ' than "Strings" we pass it verbatim to the caller
    ' The same will be done for an empty string
    If sApplicat <> "Inserts" Then
        lRc = lRcNls
        getString = sRetStr
        Exit Function
    End If
    '
    ' check if any inserts have to made
    If Not IsArray(vSubData) Then
        ReDim sSubData(0)            ' single value passed so put it
        sSubData(0) = CStr(vSubData) ' into an array to have the same processing
    Else
        sSubData = vSubData             ' put array into our array
    End If
    '
    ' scan on recognized char
    ' \*    = remainder if line is a comment and will be ignored
    ' \t    = convert to tab
    ' \n    = convert to line break
    ' \s    = convert to 1 space
    ' \(n)  = insert a text string. The number is used as index
    '
    tmp = Split(sRetStr, "\", -1, vbBinaryCompare)
    If UBound(tmp) < 1 Then
        getString = sRetStr
        Exit Function
    End If
    '
    getString = vbNullString
    For i = 0 To UBound(tmp)
        '
        ' if a line starts with a \ or ends in a \ the substring will
        ' be empty.
        ' We must take care of this because the user may want a \ at either
        ' the end or the beginning and therefore coded 2 \\ in a row
        ' Another pitfall is that a can line start with one of the
        ' characters we recognize and thus get erroneously processed as such.
        ' To distinguish we check on index (i) be zero and non-empty and
        ' skip the interpretation run
        '
        If tmp(i) = vbNullString And (i > 0 And i < UBound(tmp)) Then
            getString = getString & "\"
        '
        ' not the case so look for a command. But when the last char of the
        ' already processed string ends in a \ we skip checking because
        ' the user wants to have it not interpreted by coding n-times \ in
        ' front of it which we've honoured
        ElseIf (i > 0 And Right$(getString, 1) <> "\") Then
                If StrComp(Left$(tmp(i), 1), "n", vbBinaryCompare) = 0 Then
                    getString = getString & vbNewLine & Mid(tmp(i), 2)
                Else
                    If StrComp(Left$(tmp(i), 1), "s", vbBinaryCompare) = 0 Then
                        getString = getString & " " & Mid(tmp(i), 2)
                    Else
                        If StrComp(Left$(tmp(i), 1), "t", vbBinaryCompare) = 0 Then
                            getString = getString & vbTab & Mid(tmp(i), 2)
                        Else
                            If StrComp(Left$(tmp(i), 1), "(", vbBinaryCompare) = 0 Then
                                getString = getString + getInsert(Mid(tmp(i), 2), sSubData())
                            Else
                                If StrComp(Left$(tmp(i), 1), "*", vbBinaryCompare) = 0 Then
                                    Exit For        ' remainder of line is a comment
                                Else
                                    getString = getString & tmp(i)
                                End If
                            End If
                        End If
                    End If
                End If
            Else
                getString = getString & tmp(i)
        End If
    Next i
    '
    lRc = IIf(sFehler = vbNullString, 0, -1)
    Exit Function
    '
err_handler:
    sFehler = "Fehler in Method getString(): " & Err.Description
    '
End Function
                
Public Property Get getErr() As String
'
    getErr = sFehler
'
End Property
'
Public Function setBases(pPath As String) As Boolean
'
    sFehler = vbNullString
    setBases = False
    '
    If Not (fso.FileExists(pPath)) Then
        sFehler = "Die Datei (Grundeinstellung):  " & pPath & "  ist nicht vorhanden!"  ' $nonNLS$
    Else
        sNlsDef = pPath
        sUseNlsDsn = sNlsDef
        setBases = True
    End If
'
End Function
                
Public Function setLangPath(sLPath As String) As Boolean
'
    setLangPath = False
    sFehler = vbNullString
    '
    If (fso.FileExists(sLPath)) Then
        sNlsNls = sLPath
        sUseNlsDsn = sNlsNls
        setLangPath = True
    Else
        sFehler = "Die Datei: " & sLPath & " wurde nicht gefunden"
        sUseNlsDsn = sNlsDef
    End If
'
End Function
' --------------------------------------------------------------
' Liest einen Wert aus dessen Abschnitt und der Variable aus
' Rckgabewert Leerstring, falls ein Fehler auftritt !
' Coding: courtesy of  J. Niesner of Metallfabrik Reinhausen GmbH
' -------------------------------------------------------------
Private Function getNlsString(sDateiName As String, _
                             sVariable As String, _
                             sReturn As String, _
                             Optional sApplication As String = "Strings") As Long
    
    sFehler = "*Err*"                           ' Defaultwert, wenn ein Fehler aufgetreten ist
    lLaenge = GetPPStrings(sApplication, sVariable, sFehler, sBuffer, Len(sBuffer), sDateiName)
    
    sErgebnis = Left$(sBuffer, lLaenge)         ' C-String umwandeln
    
    If (sErgebnis = sFehler) Then               ' falls ein Fehler aufgetreten ist
        sReturn = ""                            ' wird ein Leerstring zurckgegeben
        getNlsString = -1
    Else
        sFehler = vbNullString
        sReturn = sErgebnis
    End If
'
End Function
'
'  validate the index and return the completed string
'
Private Function getInsert(sData As String, vSubs() As String) As String
'
Dim vTmp As Variant
'
    On Error GoTo err_handler:
    '
    '   an empty String stems from \( at end of string
    If sData = vbNullString Then
        getInsert = getInsert & "(" & Mid(sData, 1)
        Exit Function
    End If
    '
    ' split at closing paren
    vTmp = Split(sData, ")", -1, vbBinaryCompare)
    '
    ' an empty string here indicates this \()
    If vTmp(0) = vbNullString Then
        getInsert = getInsert & "(?)" & Mid(sData, 2)
        Exit Function
    End If
    '
    ' validate found data to integer and >= 0
    ' and check out of bounds condition
    If Not chkFld(CStr(vTmp(0)), "NZI") Then
        getInsert = getInsert & "(?" & vTmp(0) & "?" & Mid(sData, Len(vTmp(0)) + 1)
        Exit Function
    End If
    '
    ' if index is out of bounds leave text unchanged
    If Val(vTmp(0)) <= UBound(vSubs) Then  ' VB checks all conditions so AND won't work
        'If vSubs(Val(vTmp(0))) <> vbNullString Then
            getInsert = getInsert & vSubs(Val(vTmp(0))) & Mid(sData, Len(vTmp(0)) + 2)
            Exit Function         ' <=== not good
        'End If
    End If
    getInsert = getInsert & "?(" & vTmp(0) & ")?" & Mid(sData, Len(vTmp(0)) + 2)
    '
    Exit Function
    '
err_handler:
    sFehler = "Fehler in Method getInsert(): " & Err.Description
    '
End Function
'
Private Sub Class_Initialize()
'
    Set fso = New FileSystemObject
    sBuffer = String(1024, Chr$(0))            ' Puffer
'
End Sub

Private Sub Class_Terminate()
'
    Set fso = Nothing
'
End Sub

